#!
# * isogram v@version
# * Copyright (c) 2013 Shinnosuke Watanabe
# * Available under the MIT license
#

'use strict'

snippets = [
  '@file: 5params'
  '@file: 6params'
  '@file: 7params'
]

# check if the arrray contains repeated values
hasDuplicates = (el, pos, arr) ->
  arr.indexOf(el) isnt pos
  
Isogram = (characters = 'GoOgle', options) ->
  setting =
    id: 'XXXXX-X'
    domain: ''
    minify: false
    color: false

  for attrname of options
    setting[attrname] = options[attrname]  if options[attrname]

  params = characters.split ''
  
  if params.length < 5 or params.length > 7
    throw 'Please pass an argument with 5 or more and 7 or less characters.'

  if params.some hasDuplicates
    throw "#{ isogram } is not isogram."

  snippet = snippets[params.length - 5]

  if setting.color
    ansi = require 'ansi-styles'
    colorlize = (letters, color) ->
      ansi[color].open + letters + ansi[color].close
  else
    colorlize = (letters) ->
      letters

  for i in [0...params.length]
    snippet = snippet.replace(
      new RegExp("_v#{ i }_", 'g'),
      colorlize(params[i], 'green')
    )
    
  setting.id = setting.id.replace /^UA-/, ''
  if setting.domain.length > 0
    domain = '", "' + setting.domain

  additional = """\n
    ga(\"create\", \"UA-#{ setting.id + domain }\");
    ga("send", "pageview");
  """
  
  additional = additional.replace(/\s+/g, '')  if setting.minify
  
  # return result
  snippet + additional

root = this

# some AMD build optimizers like r.js check for condition patterns like the following:
if typeof define is 'function' and
   typeof define.amd is "object" and define.amd

  root.isogram = Isogram
  
  # define as an anonymous module so, through path mapping, it can be
  # referenced as the "underscore" module
  define -> Isogram

# check for `exports` after `define` in case a build optimizer adds an `exports` object
else if typeof module isnt 'undefined'
  # in Node.js or RingoJS
  (module.exports = Isogram).isogram = Isogram  if module.exports
else
  # in a browser or Rhino
  root.isogram = Isogram
